

include:
  - local: "/ci-templates/extensions/.gitlab-ci-anchors.yml"


stages:
  - test-production
  - test-staging-network-deploy
  - test-staging-cluster-deploy
  - test-staging-cluster-destroy
  - test-staging-network-destroy



default:
  tags:
    - fast


# ----------------------------------TEST: PRODUCTION -----------------------------------------

variables:
  PROJECT_ID: $CI_PROJECT_ID
  PROJECT_NAME: $CI_PROJECT_NAME
  ENVIRONMENT: test


.prod-extension:
  stage: test-production
  variables:
    VPC_CIDR: "10.9.0.0/16"
    GITLAB_ENV_NAME: production-test
  resource_group: terraform-test-prod
  rules:
    - if: $CI_COMMIT_BRANCH == "staging"
      changes:
        - environments/prod/**/*
        - modules/**/*

test-production-deploy:
  extends:
    - .production:aws:deploy
    - .prod-extension
  environment:
    name: $GITLAB_ENV_NAME
    action: start
    on_stop: "test-production-destroy"

test-production-destroy:
  extends:
    - .production:aws:destroy
    - .prod-extension
  timeout: 5m
  environment:
    name: $GITLAB_ENV_NAME
    action: stop
  when: always
  needs:
    - job: test-production-deploy
      optional: true



# --------------------------- TEST: STAGING NETWORK ------------------------------


.staging-network-extension:
  stage: test-staging-network
  variables:
    GITLAB_ENV_NAME: test-staging-networking
    VPC_CIDR: "10.10.0.0/16"
  resource_group: terraform-test-staging
  rules:
    - if: $CI_COMMIT_BRANCH == "staging"
      changes:
        - environments/staging/**/*
        - modules/**/*


test-staging-network-deploy:
  stage: test-staging-network-deploy
  extends:
    - .optional:aws_staging_network:prepare
    - .staging-network-extension
  environment:
    name: $GITLAB_ENV_NAME
    on_stop: "test-staging-network-destroy"
    action: start



test-staging-network-destroy:
  stage: test-staging-network-destroy
  extends:
    - .optional:aws_staging_network:destroy
    - .staging-network-extension
  when: always
  environment:
    name: $GITLAB_ENV_NAME
    action: stop


# -------------------------------- TEST: STAGING CLUSTER----------------------------------

.staging-cluster-extension:
  stage: test-staging-cluster
  variables:
    GITLAB_ENV_NAME: test-staging-cluster
  resource_group: terraform-test-staging
  rules:
    - if: $CI_COMMIT_BRANCH == "staging"
      changes:
        - environments/staging/2-ecs-stack/**/*
        - modules/**/*



test-staging-cluster-deploy:
  stage: test-staging-cluster-deploy
  extends:
    - .staging:aws_cluster:deploy
    - .staging-cluster-extension
  after_script:
    - echo "Url is $(terraform output -raw elb_url)"
  environment:
    name: $GITLAB_ENV_NAME
    on_stop: "test-staging-cluster-destroy"
    action: start



test-staging-cluster-destroy:
  stage: test-staging-cluster-destroy
  extends:
    - .staging:aws_cluster:destroy
    - .staging-cluster-extension
  when: always
  timeout: 5m
  environment:
    name: $GITLAB_ENV_NAME
    action: stop

